import { CopyTo, FindOptions, ModifyAs, ReadAs, RunOptions, RunResult, WriteAs } from "./functions";
import { Logger } from "./logger";
import { File, Files, Nothing } from "./types";
export default class Nehemiah {
    readonly cwd: string;
    readonly logger: Logger;
    readonly name: string;
    private readonly context;
    constructor(cwd?: string);
    find(globs: string | string[], options?: FindOptions): Files;
    findOneOrError(glob: string, options?: FindOptions): File;
    findOneOrWarning(glob: string, options?: FindOptions): File;
    exists(glob: string): File;
    copy(glob: string, ...globs: string[]): CopyTo;
    delete(globs: string | string[]): Files;
    read(glob: string): ReadAs;
    write(filename: string): WriteAs;
    modify(filename: string): ModifyAs;
    merge(globs: string | string[], filename: string): Nothing;
    run(cmd: string, options?: RunOptions): RunResult;
    warn(...args: any[]): void;
}
//# sourceMappingURL=Nehemiah.d.ts.map