"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const functions_1 = require("./functions");
const logger_1 = require("./logger");
class Nehemiah {
    constructor(cwd = process.cwd()) {
        this.cwd = cwd;
        this.logger = new logger_1.Logger();
        this.name = path_1.default.basename(this.cwd);
        this.context = this;
    }
    find(globs, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.findFiles(this.context, globs, options);
        });
    }
    findOneOrError(glob, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.findOneFileOrError(this.context, glob, options);
        });
    }
    findOneOrWarning(glob, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.findOneFileOrWarn(this.context, glob, options);
        });
    }
    exists(glob) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.fileExists(this.context, glob);
        });
    }
    copy(glob, ...globs) {
        return functions_1.copyFile(this.context, glob, ...globs);
    }
    delete(globs) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.deleteFiles(this.context, globs);
        });
    }
    read(glob) {
        return functions_1.readFile(this.context, glob);
    }
    write(filename) {
        return functions_1.writeFile(this.context, filename);
    }
    modify(filename) {
        return functions_1.modifyFile(this.context, filename);
    }
    merge(globs, filename) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.mergeFile(this.context, globs, filename);
        });
    }
    run(cmd, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return functions_1.runCommand(this.context, cmd, options);
        });
    }
    warn(...args) {
        this.logger.warn(...args);
    }
}
exports.default = Nehemiah;
//# sourceMappingURL=Nehemiah.js.map