"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const nehemiah_1 = __importDefault(require("nehemiah"));
const projects = ["a", "b", "c"];
function updateProject(dir) {
    return __awaiter(this, void 0, void 0, function* () {
        const n = new nehemiah_1.default(dir);
        const updatePackage = () => n.modify("package.json")
            .asJson(p => {
            p.author = "Esra";
            if (!Array.isArray(p.keywords) || p.keywords.length < 3) {
                n.warn("Not enough keywords");
            }
        });
        const shouldHaveLicense = () => __awaiter(this, void 0, void 0, function* () {
            if (!(yield n.exists("license*"))) {
                n.warn("Missing license");
            }
        });
        const deleteLogs = () => __awaiter(this, void 0, void 0, function* () { return n.delete("*.log"); });
        const updateEditorConfig = () => __awaiter(this, void 0, void 0, function* () { return n.copy(__dirname, "templates/.editorconfig").to(".editorconfig"); });
        const updateMinorPatch = () => __awaiter(this, void 0, void 0, function* () { return n.run("yarn upgrade --mutext file"); });
        const gitFetchPrune = () => n.run("git fetch --prune");
        yield Promise.all([
            updatePackage,
            shouldHaveLicense,
            deleteLogs,
            updateEditorConfig,
            updateMinorPatch,
            gitFetchPrune,
        ]);
    });
}
(() => __awaiter(void 0, void 0, void 0, function* () {
    for (const dir of projects) {
        yield updateProject(dir);
    }
}))();
//# sourceMappingURL=example.js.map