"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cp_file_1 = __importDefault(require("cp-file"));
const lodash_1 = require("lodash");
const path_1 = __importDefault(require("path"));
const find_1 = require("./find");
const path_2 = require("./path");
const defaultOptions = {
    overwrite: true,
};
/**
 * https://github.com/sindresorhus/cp-file#api
 */
function copyFile(context, glob, ...globs) {
    const to = {
        to(target) {
            return __awaiter(this, void 0, void 0, function* () {
                const sourceGlob = path_1.default.join(glob, ...globs);
                const source = yield find_1.findOneFileOrError(context, sourceGlob);
                const sourceFile = path_2.inContext(source, context);
                const targetFile = path_2.inContext(target, context);
                const options = lodash_1.merge({ cwd: context.cwd }, defaultOptions);
                return cp_file_1.default(sourceFile, targetFile, options);
            });
        },
    };
    return to;
}
exports.copyFile = copyFile;
//# sourceMappingURL=copy.js.map