"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const del_1 = __importDefault(require("del"));
const path_1 = __importDefault(require("path"));
const exists_1 = require("./exists");
const defaultOptions = {
    dot: true,
    expandDirectories: true,
    gitignore: false,
    onlyFiles: false,
    force: true,
};
/**
 * https://github.com/sindresorhus/del#api
 */
function deleteFiles(context, globs) {
    return __awaiter(this, void 0, void 0, function* () {
        const options = Object.assign({ cwd: context.cwd }, defaultOptions);
        if (!Array.isArray(globs)) {
            globs = [globs];
        }
        const deletions = globs.map(glob => {
            return deleteFile(context, glob, options);
        });
        const fileArrs = yield Promise.all(deletions);
        return Array.prototype.concat(...fileArrs);
    });
}
exports.deleteFiles = deleteFiles;
function deleteFile(context, glob, options) {
    return __awaiter(this, void 0, void 0, function* () {
        const exists = yield exists_1.fileExists(context, glob);
        if (exists) {
            const file = path_1.default.join(options.cwd, exists);
            return del_1.default(file, options);
        }
        else {
            return Promise.resolve([]);
        }
    });
}
//# sourceMappingURL=delete.js.map