"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const find_1 = require("./find");
const read_1 = require("./read");
const write_1 = require("./write");
function mergeFile(context, globs, filename) {
    return __awaiter(this, void 0, void 0, function* () {
        const files = yield find_1.findFiles(context, globs);
        if (files.length === 0) {
            context.logger.warn("No source files found: " + JSON.stringify(globs) + ": Skipping merge");
            return;
        }
        const promises = files.map((file) => __awaiter(this, void 0, void 0, function* () { return yield read_1.readFile(context, file).asText(); }));
        const fileContents = yield Promise.all(promises);
        const merged = fileContents.filter(lines => lines).join("\n\n");
        yield write_1.writeFile(context, filename).asText(merged);
    });
}
exports.mergeFile = mergeFile;
//# sourceMappingURL=merge.js.map