"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const read_1 = require("./read");
const write_1 = require("./write");
function modifyFile(context, filename) {
    const read = read_1.readFile(context, filename);
    const write = write_1.writeFile(context, filename);
    return new ModifyAs(read, write);
}
exports.modifyFile = modifyFile;
class ModifyAs {
    constructor(read, write) {
        this.read = read;
        this.write = write;
    }
    asText(modify) {
        return __awaiter(this, void 0, void 0, function* () {
            const value = yield this.read.asText();
            const modified = value ? (yield modify(value)) || value : value;
            yield this.write.asText(modified);
        });
    }
    asJson(modify) {
        return __awaiter(this, void 0, void 0, function* () {
            const value = yield this.read.asJson();
            const modified = value ? (yield modify(value)) || value : value;
            yield this.write.asJson(modified);
        });
    }
    asLines(modify) {
        return __awaiter(this, void 0, void 0, function* () {
            const value = yield this.read.asLines();
            const modified = value ? (yield modify(value)) || value : value;
            yield this.write.asLines(modified);
        });
    }
}
exports.ModifyAs = ModifyAs;
//# sourceMappingURL=modify.js.map